#include <SPI.h>
#include "RCTractorGuyRF24.h"

// Set up nRF24L01 radio on SPI bus plus pins 9 & 10
RF24 radio(9, 10);

bool Radio_Attached = 0;
uint8_t PALevel;
uint8_t DataRate;

void setup() {
   // Start Serial Communications
  Serial.begin(9600);

  // Start the NRF24L01
  Radio_Attached = radio.begin();


     Serial.print("Attached:");
     if(Radio_Attached == 0){Serial.println("No");}
      else if(Radio_Attached == 1){Serial.println("Yes");}

      Serial.print("Variant:");
      
      uint8_t Variant = radio.isPVariant();

      if(Variant == 0){Serial.println("nRF24L01");}
      else if(Variant == 1){Serial.println("nRF24L01+");}

     

        for (int testnum = 0; testnum < 3; testnum++) {

        Serial.println("\n");

        if(testnum == 0){
           Serial.println("Data Rate Test 1/3");
           Serial.println("Setting to 1 Mbps");
           radio.setDataRate(RF24_1MBPS);    
        }
        else if(testnum == 1){
          Serial.println("Data Rate Test 2/3");
          Serial.println("Setting to 2 Mbps");
          radio.setDataRate(RF24_2MBPS);
        }
        else if(testnum == 2){
          Serial.println("Data Rate Test 3/3");
          Serial.println("Setting to 250 kbps");
          radio.setDataRate(RF24_250KBPS);
        }

        DataRate = radio.getDataRate();

        if(DataRate == 0){Serial.println("Response: 1 Mbps");}
        else if(DataRate == 1){Serial.println("Response: 2 Mbps");}
        else if(DataRate == 2){Serial.println("Response: 250 kbps");}

        if(testnum == DataRate){Serial.println("Result: Match");}else{Serial.println("Result: Fail");}

        delay(100);
      }



        for (int testnum = 0; testnum < 4; testnum++) {

        Serial.println("\n");

        if(testnum == 0){
          Serial.println("Power Amp Test 1/4");
          Serial.println("Setting to Min");
          radio.setPALevel(RF24_PA_MIN);
        }
        else if(testnum == 1){
          Serial.println("Power Amp Test 2/4");
          Serial.println("Setting to Low");
          radio.setPALevel(RF24_PA_LOW);
        }
        else if(testnum == 2){
          Serial.println("Power Amp Test 3/4");
          Serial.println("Setting to High");
          radio.setPALevel(RF24_PA_HIGH);
        }
        else if(testnum == 3){
          Serial.println("Power Amp Test 4/4");
          Serial.println("Setting to Max");
          radio.setPALevel(RF24_PA_MAX);
        }

        PALevel = radio.getPALevel();
        if(PALevel == 0){Serial.println("Response: Min");}
        else if(PALevel == 1){Serial.println("Response: Low");}
        else if(PALevel == 2){Serial.println("Response: High");}
        else if(PALevel == 3){Serial.println("Response: Max");}

        if(testnum == PALevel){Serial.println("Match");}else{Serial.println("Fail");}

      delay(100);
      }
}

void loop() {
 
}
